freeslot("sfx_tjump2", "sfx_tjump3", "sfx_spindm", "S_PLAY_FRONTFLIPO", "S_PLAY_FRONTFLIPT", "S_PLAY_SWAPJUMP")
sfxinfo[sfx_tjump2].caption = "Skip"
sfxinfo[sfx_tjump3].caption = "Hop"
sfxinfo[sfx_spindm].caption = "Re-Curl"
states[S_PLAY_FRONTFLIPO] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SWAPJUMP}
states[S_PLAY_FRONTFLIPT] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SPRING}
states[S_PLAY_SWAPJUMP] = {SPR_PLAY, SPR2_LAND, 20, nil, 0,  0, S_PLAY_FALL} //swap your arms when you jump

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo.valid
		and(player.mo.skin == "dummie") then
			player.powers[pw_underwater] = 0
			player.powers[pw_spacetime] = 0
		end
	end
end)


addHook("MobjThinker", function(dummie)
	dummie.player.spcanflip = false
	//it'd be dumb if any of this was applied to a dif. character so
	if (dummie and dummie.skin == "dummie") 
	and dummie.player.playerstate == PST_LIVE 
		
		if (dummie.state == S_PLAY_SUPER_TRANS1) //Make sure you won't bounce when you go super!
			dummie.player.pflags = $1|PF_THOKKED
		end
		
		
		//variable making
		if dummie.player.jumpnumber == nil 
			dummie.player.jumpnumber = 0 
			dummie.player.justjumped = 0
			dummie.player.jumpcheck = 0
		end
		if P_IsObjectOnGround(dummie) 
		and dummie.player.jumpcheck == 0 
			dummie.player.jumpnumber = 0 
		end
		
		//to prevent immediate double or triple jump
		if dummie.player.usedown == nil 
		or not (dummie.player.cmd.buttons & BT_JUMP) 
			dummie.player.usedown = 0
			dummie.player.justjumped = 0 
		end
		if P_IsObjectOnGround(dummie) 
		and (dummie.player.cmd.buttons & BT_JUMP) 
			dummie.player.usedown = 1 
		end
		
		//to prevent immediate recurl
		if dummie.player.spindown == nil 
		or not (dummie.player.cmd.buttons & BT_SPIN) 
			dummie.player.spindown = 0
		end
		if P_IsObjectOnGround(dummie) 
		and (dummie.player.cmd.buttons & BT_SPIN) 
			dummie.player.spindown = 1 
		end
		
		//----------------------------------------------------------------------
		
		if dummie.player.pflags & PF_JUMPED 
		and dummie.player.usedown == 0 
		and not (dummie.player.pflags & PF_THOKKED) 
		and dummie.player.cmd.buttons & BT_JUMP 
		and dummie.player.jumpcheck == 0 
		and not (dummie.player.exiting) 
		and dummie.health 
		and not (P_PlayerInPain(dummie.player)) 
			dummie.player.jumpcheck = 1 
		end
			
		//jumping time, lets make sure a bunch of stuff aint happenin when we do it first		
		if not (dummie.player.pflags & PF_SPINNING) 
		and not (dummie.player.pflags & PF_STARTDASH) 
		and not (dummie.tracer and dummie.tracer.type == MT_TUBEWAYPOINT) 
		and dummie.player.jumpcheck == 1 
		and dummie.health 
		and not (P_PlayerInPain(dummie.player)) 
		or dummie.player.jumpcheck == 1
		and not P_IsObjectOnGround(dummie)
			//first jump
			if dummie.player.jumpnumber == 0 
				dummie.player.justjumped = 1 
				dummie.player.jumpnumber = 1 //you just jumped weenie congrats
				dummie.player.pflags = $1|PF_JUMPED 
				dummie.player.pflags = $1 & ~PF_SPINNING
			end
			
			//second jump
			if dummie.player.jumpnumber == 1 
			and dummie.player.justjumped == 0 
			and not (P_PlayerInPain(dummie.player)) 
			and not (dummie.eflags & MFE_JUSTHITFLOOR)
				dummie.player.justjumped = 1 
				dummie.player.jumpnumber = 2 //on your second jump, cool
				dummie.player.pflags = $1|PF_JUMPED 
				dummie.state = S_PLAY_FRONTFLIPO //cool flip bro
				dummie.player.pflags = $1 & ~PF_SPINNING
				//this may look complicated but it's just how to send dummie upward
				if (dummie.player.powers[pw_super])
					 if dummie.eflags & MFE_UNDERWATER
						P_SetObjectMomZ(dummie, 6*FRACUNIT)
					else
						P_SetObjectMomZ(dummie, 12*FRACUNIT)
					end
					S_StartSound(dummie.player.mo, sfx_tjump2)
					P_SpawnMobj(dummie.player.mo.x, dummie.player.mo.y, dummie.player.mo.z, MT_SPINDUST)
				else 
					 if dummie.eflags & MFE_UNDERWATER
						P_SetObjectMomZ(dummie, 5*FRACUNIT)
					else
						P_SetObjectMomZ(dummie, 8*FRACUNIT)
					end

					S_StartSound(dummie.player.mo, sfx_tjump2)
					P_SpawnMobj(dummie.player.mo.x, dummie.player.mo.y, dummie.player.mo.z, MT_SPINDUST)
				end
			end
			
			//third jump
			if dummie.player.jumpnumber == 2 
			and dummie.player.justjumped == 0 
			and not (P_PlayerInPain(dummie.player))
			and not (dummie.eflags & MFE_JUSTHITFLOOR)
				dummie.player.justjumped = 1 
				dummie.player.jumpnumber = 3 //and now that you did your third jump, this resets
				dummie.player.pflags = $1 & ~PF_SPINNING
				//again may look complicated but its just the height part
				if (dummie.player.powers[pw_super])
					 if dummie.eflags & MFE_UNDERWATER
						P_SetObjectMomZ(dummie, 5*FRACUNIT)
					else
						P_SetObjectMomZ(dummie, 9*FRACUNIT)
					end
					S_StartSound(dummie.player.mo, sfx_tjump3)
				else 
					 if dummie.eflags & MFE_UNDERWATER
						P_SetObjectMomZ(dummie, 4*FRACUNIT)
					else
						P_SetObjectMomZ(dummie, 7*FRACUNIT)
					end
					S_StartSound(dummie.player.mo, sfx_tjump3)
				end
				dummie.state = S_PLAY_FRONTFLIPT //cool flip bro
				P_SpawnMobj(dummie.player.mo.x, dummie.player.mo.y, dummie.player.mo.z, MT_SPINDUST)
				dummie.player.pflags = $|PF_JUMPED
			end
			dummie.player.jumpcheck = 0
			dummie.player.usedown = 1 	
		end
		if P_IsObjectOnGround(dummie)
			dummie.player.jumpnumber = 0
		end
		
		//jump whenever
		if not P_IsObjectOnGround(dummie)
		and not (dummie.player.pflags & PF_JUMPED)
		and (dummie.player.cmd.buttons & BT_JUMP)
		and dummie.player.usedown == 0
		and (dummie.player.powers[pw_shield]) != SH_WHIRLWIND
			dummie.player.pflags = $|PF_JUMPED
			dummie.player.pflags = $1 & ~PF_THOKKED
			if dummie.player.jumpnumber == 0
				dummie.player.jumpnumber = 1
			end
		end
		
		
		
		//making sure things dont get fuckd
		if not (dummie.player.pflags & PF_JUMPED) 
		or (dummie.eflags & MFE_JUSTHITFLOOR)
			dummie.player.jumpcheck = 0 
		end
		
		//reset jumps if carried
		if dummie.player.powers[pw_carry]
		or dummie.player.powers[pw_carry] == CR_MACESPIN
			dummie.player.jumpcheck = 0 
			dummie.player.jumpnumber = 0
		end
		//self explanatory
		if not (dummie.player.pflags & PF_JUMPED) 
			dummie.player.jumpcheck = 0
		end
		
		//stop freaking out when you jump the second you hit the ground
		if (dummie.eflags & MFE_JUSTHITFLOOR)
		and dummie.player.cmd.buttons & BT_JUMP
			dummie.player.jumpnumber = 1
		end
		//you too
		if (dummie.eflags & MFE_JUSTHITFLOOR)
		and dummie.player.pflags & PF_JUMPED
		or P_IsObjectOnGround(dummie) and dummie.player.pflags & PF_JUMPED
			dummie.player.jumpnumber = 1
		end	
		
		//----------------------------------------------------------------------
		
		//time to start rolling on the ground lol
		if not (dummie.player.powers[pw_carry] == CR_NIGHTSMODE) //you cant roll in the special stages idot
			if dummie.player.speed <= FixedMul(4*FRACUNIT+FRACUNIT/2, dummie.player.mo.scale)
			and not (dummie.player.pflags & PF_SPINNING)
				dummie.player.charability2 = CA2_NONE
			else 
				dummie.player.charability2 = CA2_SPINDASH
			end
			if dummie.player.pflags & PF_STARTDASH
				dummie.player.pflags = $1 & ~PF_STARTDASH
				dummie.player.pflags = $1 & ~PF_SPINNING
				dummie.state = S_PLAY_STND //unlike a certain egg who kinda does the same thing, stop moving on your ass and get up
			end
			
			
			//recurl in the air moment numero sinco
			if (dummie.player.cmd.buttons & BT_SPIN)
			and not (P_PlayerInPain(dummie.player))
			and not P_IsObjectOnGround(dummie)
			and not (dummie.player.pflags & PF_SPINNING)
			and not (dummie.player.powers[pw_carry])
			and not (dummie.player.pflags & PF_THOKKED)
			and not (dummie.state == S_PLAY_SUPER_TRANS1)
			and dummie.player.spindown == 0
				
				S_StartSound(dummie.player.mo, sfx_spindm)
				dummie.player.pflags = $|PF_SPINNING
				dummie.state = S_PLAY_ROLL
				if (dummie.player.pflags & PF_JUMPED)
					dummie.player.pflags = $1 & ~PF_JUMPED
				end
				dummie.player.spindown = 1
			end
			
			//so you wanna stop sPEEENing i see
			if (dummie.player.cmd.buttons & BT_SPIN)
			and dummie.player.spindown == 0
			and (dummie.player.pflags & PF_SPINNING)
			and (dummie.player.powers[pw_shield]) != SH_WHIRLWIND
			and not (dummie.player.powers[pw_carry])
			and not (dummie.player.pflags & PF_THOKKED)
			and not (dummie.state == S_PLAY_SUPER_TRANS1)
			and not P_IsObjectOnGround(dummie)
				if dummie.player.jumpnumber == 0
					dummie.player.jumpnumber = 1
				end
				if (dummie.player.powers[pw_shield]) != SH_WHIRLWIND
					dummie.player.pflags = $|PF_JUMPED
				end
				dummie.player.pflags = $1 & ~PF_SPINNING
				dummie.player.spindown = 1
				dummie.state = S_PLAY_FALL
			end
			//extra check
			if (dummie.player.pflags & PF_SPINNING)
			and (dummie.player.cmd.buttons & BT_SPIN)
			and dummie.player.spindown == 0
				if dummie.player.jumpnumber == 0
					dummie.player.jumpnumber = 1
				end
				if (dummie.player.powers[pw_shield]) != SH_WHIRLWIND
					dummie.player.pflags = $|PF_JUMPED
				end
				dummie.player.pflags = $1 & ~PF_SPINNING
				dummie.player.spindown = 1
				dummie.state = S_PLAY_FALL
			end
		end
	end
end, MT_PLAYER)